unit SiteMan;

interface

uses BWGraphs, ExtCtrls, ComCtrls, Classes, Forms;

type TSite = class
       public
        Shutdown : boolean;
        Address  : string;
        HostName : string;
        Timeout  : integer;
        DataSize : integer;
        Graph : TBWGraph;
        Sheet : TTabSheet;
        ThreadList : TList;

        procedure Start;
        destructor Destroy; override;
        procedure TimerProc;
        procedure OnThreadFinish(Sender:TObject);
     end;

implementation

uses PingThread;

procedure TSite.Start;
begin
  ThreadList:=TList.Create;
end;

destructor TSite.Destroy;
var i:integer;
    Thread1 : TPingThread;
begin
  while ThreadList.Count>0 do
    Application.ProcessMessages;
  ThreadList.Free;
  inherited;
end;

procedure TSite.OnThreadFinish(Sender:TObject);
begin
  ThreadList.Remove(Sender);
end;

procedure TSite.TimerProc;
var Thread, Thread1 : TPingThread;
    i : integer;
begin
  if Shutdown then exit;
  Thread := TPingThread.Create(true);
  Thread.Address:=Address;
  Thread.Graph:=Graph;
  Thread.FreeOnTerminate:=true;
  Thread.OnTerminate:=OnThreadFinish;
  ThreadList.Add(Thread);
  Thread.Resume;
end;

end.
